package honicka;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.HashMap;
import java.util.Vector;

/**
 * <p>Title: Jednoducha honicka pro dva hrace</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: </p>
 * @author Miroslav Balik
 * @version 1.0
 */

public class Frame1
    extends JFrame {
  Konfigurace ko =  new Konfigurace();
  JPanel contentPane;
  JMenuBar jMenuBar1 = new JMenuBar();
  JMenu jMenuFile = new JMenu();
  JMenuItem jMenuFileExit = new JMenuItem();
  JMenu jMenuHelp = new JMenu();
  JMenuItem jMenuHelpAbout = new JMenuItem();
  ImageIcon image1;
  ImageIcon image2;
  ImageIcon image3;
  JLabel statusBar = new JLabel();
  BorderLayout borderLayout1 = new BorderLayout();
  HraciPlocha plocha = new HraciPlocha(ko);
  ListOfKeys klavesy = new ListOfKeys(200);
  final java.util.Timer timer = new java.util.Timer();

  //Construct the frame
  public Frame1() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception {
    image1 = new ImageIcon(honicka.Frame1.class.getResource("openFile.png"));
    image2 = new ImageIcon(honicka.Frame1.class.getResource("closeFile.png"));
    image3 = new ImageIcon(honicka.Frame1.class.getResource("help.png"));
    contentPane = (JPanel)this.getContentPane();
    contentPane.setLayout(borderLayout1);
    this.setSize(new Dimension(524, 480));
    this.setTitle("Frame Title");
    statusBar.setText(" ");
    jMenuFile.setText("File");
    jMenuFileExit.setText("Exit");
    jMenuFileExit.addActionListener(new Frame1_jMenuFileExit_ActionAdapter(this));
    jMenuHelp.setText("Help");
    jMenuHelpAbout.setText("About");
    jMenuHelpAbout.addActionListener(new Frame1_jMenuHelpAbout_ActionAdapter(this));
    plocha.addKeyListener(new Frame1_plocha_keyAdapter(this));
    jMenuFile.add(jMenuFileExit);
    jMenuHelp.add(jMenuHelpAbout);
    jMenuBar1.add(jMenuFile);
    jMenuBar1.add(jMenuHelp);
    this.setJMenuBar(jMenuBar1);
    contentPane.add(statusBar, BorderLayout.SOUTH);
    contentPane.add(plocha, BorderLayout.CENTER);
    timer.scheduleAtFixedRate(new java.util.TimerTask() {
      public void run() {
        ticTak();
      }
    }
    , 300, 50); //spozdeni pred prvnim, prodleva mezi tiky
  }

  public void ticTak() {
    if (klavesy.isEmpty()) {
//      System.out.println("nic....");
      return; // neni stisknuta zadna klavesa, nedelej nic
    }
    for (int i = 0; i < klavesy.size(); i++) {
      int krok1 = 4; //vetsi krok, vetsi rychlost
      int krok2 = 3;  // rychlost druheho hrace
      Point h1=new Point(),h2 = new Point();  // posun hrace 1 a hrace 2
      int kl = klavesy.getKey(i);
      if(kl == ko.hrac1Down)h1.y = krok1;
      else if(kl == ko.hrac1Up)h1.y = -krok1;
      else if(kl == ko.hrac1Left)h1.x = -krok1;
      else if(kl == ko.hrac1Right)h1.x = krok1;
      else if(kl == ko.hrac2Down)h2.y = krok2;
      else if(kl == ko.hrac2Up)h2.y = -krok2;
      else if(kl == ko.hrac2Left)h2.x = -krok2;
      else if(kl == ko.hrac2Right)h2.x = krok2;
      plocha.hrac1.move(h1);
      plocha.hrac2.move(h2);
      plocha.repaint();
//      System.out.print(" " + kl);
    }
//    System.out.println("");
//        System.out.println("Tic tac");

  }

  //File | Exit action performed
  public void jMenuFileExit_actionPerformed(ActionEvent e) {
    System.exit(0);
  }

  //Help | About action performed
  public void jMenuHelpAbout_actionPerformed(ActionEvent e) {
    Frame1_AboutBox dlg = new Frame1_AboutBox(this);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation( (frmSize.width - dlgSize.width) / 2 + loc.x,
                    (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.pack();
    dlg.show();
  }

  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      jMenuFileExit_actionPerformed(null);
    }
  }

  void plocha_keyPressed(KeyEvent e) {
//    System.out.print("Stisknuto "+ e.getKeyCode()+":"+e.getKeyChar()+":"+e.getKeyLocation()+":");
    int keyCode = e.getKeyCode();
    if(!klavesy.contains(keyCode))klavesy.add(keyCode);
  }

  void plocha_keyReleased(KeyEvent e) {
    klavesy.remove(e.getKeyCode());
    //System.out.println("Pusteno " + e.getKeyCode());
   // if (klavesy.contains(e.getKeyCode())) {
      //      System.out.println("Je tam"); //  [e.getKeyCode()] = false;
    //}
  }
}

class Frame1_jMenuFileExit_ActionAdapter
    implements ActionListener {
  Frame1 adaptee;

  Frame1_jMenuFileExit_ActionAdapter(Frame1 adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuFileExit_actionPerformed(e);
  }
}

class Frame1_jMenuHelpAbout_ActionAdapter
    implements ActionListener {
  Frame1 adaptee;

  Frame1_jMenuHelpAbout_ActionAdapter(Frame1 adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuHelpAbout_actionPerformed(e);
  }
}

class Frame1_plocha_keyAdapter
    extends java.awt.event.KeyAdapter {
  Frame1 adaptee;

  Frame1_plocha_keyAdapter(Frame1 adaptee) {
    this.adaptee = adaptee;
  }

  public void keyPressed(KeyEvent e) {
    adaptee.plocha_keyPressed(e);
  }

  public void keyReleased(KeyEvent e) {
    adaptee.plocha_keyReleased(e);
  }
}